<?php

namespace app\admin\model;

use think\Model;


class Job extends Model
{

    

    

    // 表名
    protected $name = 'job';
    
    // 自动写入时间戳字段
    protected $autoWriteTimestamp = 'int';

    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = 'updatetime';
    protected $deleteTime = false;

    // 追加属性
    protected $append = [
        'type_text',
        'lookdata_text',
        'putdata_text'
    ];
    
    protected static function init()
    {
        self::afterInsert(function ($row) {
            $row->save(['weigh' => $row['id']]);
        });
    }
    
    public function getTypeList()
    {
        return ['1' => __('Type 1'), '2' => __('Type 2'), '3' => __('Type 3')];
    }


    public function getTypeTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['type']) ? $data['type'] : '');
        $valueArr = explode(',', $value);
        $list = $this->getTypeList();
        return implode(',', array_intersect_key($list, array_flip($valueArr)));
    }

    public function getLookdataList()
    {
        return ['0' => __('Lookdata 0'), '1' => __('Lookdata 1'),'2'=>__('Lookdata 2')];
    }

    public function getLookdataTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['lookdata']) ? $data['lookdata'] : '');
        $list = $this->getLookdataList();
        return isset($list[$value]) ? $list[$value] : '';
    }


    public function getPutdataList()
    {
        return ['0' => __('Putdata 0'), '1' => __('Putdata 1')];
    }

    public function getPutdataTextAttr($value, $data)
    {
        $value = $value ? $value : (isset($data['putdata']) ? $data['putdata'] : '');
        $list = $this->getPutdataList();
        return isset($list[$value]) ? $list[$value] : '';
    }
    protected function setTypeAttr($value)
    {
        return is_array($value) ? implode(',', $value) : $value;
    }


}
