<?php

namespace app\api\model;

use think\Model;

class Job extends Model
{

    // 开启自动写入时间戳字段
    protected $autoWriteTimestamp = 'int';
    // 定义时间戳字段名
    protected $createTime = 'createtime';
    protected $updateTime = 'updatetime';
    protected $append = [
        'label_name',
    ];

    // 格式化封面图
    public function getCoverAttr($value){
        return empty($value) ? '' : cdnurl($value,true);
    }

    //标签
    public function getLabelNameAttr($value,$data){
        if (empty($data['label_ids'])){
            return [];
        }
        $project_ids = explode(",", $data['label_ids']);
        $project = [];
        foreach ($project_ids as $j){
            $project[]= model('\app\common\model\Label')->where(['id'=>$j])->value('title');
        }
        return $project;
    }

    // 格式化图片
    public function getImagesAttr($value,$data){
        $arr = [];
        if(!empty($data['video'])){
            $arr[] = ['type'=>'video','url'=>cdnurl($data['video'],true)];
        }
        $images_arr = explode(',',$value);
        foreach ($images_arr as &$v){
            $arr[] = ['type'=>'image','url'=>cdnurl($v,true)];
        }
        return $arr;
    }
}
