define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'factory/index' + location.search,
                    add_url: 'factory/add',
                    edit_url: 'factory/edit',
                    del_url: 'factory/del',
                    multi_url: 'factory/multi',
                    import_url: 'factory/import',
                    table: 'factory',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'weigh',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'factory_name', title: __('Factory_name'), operate: 'LIKE'},
                        {field: 'factory_shortname', title: __('Factory_shortname'), operate: 'LIKE'},
                        {field: 'factory_price', title: __('Factory_price'), operate:'BETWEEN'},
                        {field: 'borrow_money', title: __('Borrow_money'), operate:'BETWEEN'},
                        {field: 'work_subsidy', title: __('Work_subsidy'), operate: false},
                        {field: 'weigh', title: __('Weigh'), operate: false},
                        //操作栏,默认有编辑、删除或排序按钮,可自定义配置buttons来扩展按钮
                        {
                            field: 'operate',
                            title: __('Operate'),
                            table: table,
                            events: Table.api.events.operate,
                            buttons: [
                                {
                                    name: 'factory_admin',
                                    text: __('设置驻厂'),
                                    title: __('设置驻厂'),
                                    classname: 'btn btn-xs btn-primary btn-dialog',
                                    icon: 'fa fa-edit',
                                    url: 'factory_admin/index?factory_id={id}',
                                }
                            ],
                            formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});