define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'factory_user/index' + location.search,
                    add_url: 'factory_user/add',
                    edit_url: 'factory_user/edit',
                    del_url: 'factory_user/del',
                    multi_url: 'factory_user/multi',
                    import_url: 'factory_user/import',
                    table: 'factory_user',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'user.nickname', title: __('User.nickname'), operate: 'LIKE'},
                        {field: 'factory.factory_name', title: __('Factory.factory_name'), operate: 'LIKE'},
                        {field: 'status', title: __('Status'), searchList: {"0":__('Status 0'),"1":__('Status 1'),"2":__('Status 2'),"3":__('Status 3')}, formatter: Table.api.formatter.status},
                        {field: 'join_time', title: __('Join_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'quit_time', title: __('Quit_time'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        //操作栏,默认有编辑、删除或排序按钮,可自定义配置buttons来扩展按钮
                        {
                            field: 'operate',
                            title: __('Operate'),
                            table: table,
                            events: Table.api.events.operate,
                            buttons: [
                                {
                                    name: 'examine',
                                    text: '通过',
                                    title: '通过',
                                    classname: 'btn btn-xs btn-success btn-ajax',
                                    icon: '',
                                    url: 'factory_user/examine?realname_id={id}&status=1',
                                    confirm: '是否确认通过？',
                                    visible:function (row) {
                                        if(row.status == '0'){
                                            return true;
                                        }
                                    },
                                    success: function (data) {
                                        table.bootstrapTable('refresh');
                                    }
                                },
                                {
                                    name: 'examine',
                                    text: '驳回',
                                    title: '驳回',
                                    classname: 'btn btn-xs btn-danger btn-ajax',
                                    icon: '',
                                    url: 'factory_user/examine?realname_id={id}&status=2',
                                    confirm: '是否确认驳回？',
                                    visible:function (row) {
                                        if(row.status == '0'){
                                            return true;
                                        }
                                    },
                                    success: function (data) {
                                        table.bootstrapTable('refresh');
                                    }
                                }
                            ],
                            formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});