define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'user/user_recruit_subsidy_log/index' + location.search,
                    // add_url: 'user/user_recruit_subsidy_log/add',
                    // edit_url: 'user/user_recruit_subsidy_log/edit',
                    // del_url: 'user/user_recruit_subsidy_log/del',
                    // multi_url: 'user/user_recruit_subsidy_log/multi',
                    // import_url: 'user/user_recruit_subsidy_log/import',
                    table: 'user_recruit_subsidy_log',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        // {field: 'user_id', title: __('User_id')},
                        {field: 'children.nickname', title: __('Children.nickname'), operate: 'LIKE'},
                        {field: 'children.avatar', title: __('Children.avatar'), operate: 'LIKE', events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'recruit_subsidy', title: __('Recruit_subsidy'), operate:'BETWEEN'},
                        {field: 'children_id', title: __('Children_id'),visible:false},
                        // {field: 'work_date', title: __('Work_date')},
                        // {field: 'user_work_log_id', title: __('User_work_log_id')},
                        {field: 'leave', title: __('Leave'), searchList: {"0":__('Leave 0'),"1":__('Leave 1')}, formatter: Table.api.formatter.normal},

                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        // {field: 'leave', title: __('Leave')},
                        {field: 'operate', title: __('Operate'), table: table,
                            events: Table.api.events.operate,
                            buttons: [{
                                name: 'indexof',
                                text: __('查看收益'),
                                icon: 'fa fa-list',
                                classname: 'btn btn-info btn-xs btn-detail btn-dialog',
                                url: 'user/user_recruit_subsidy_log/indexof?xia_id={children_id}'
                            }],
                            formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        indexof: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'user/user_recruit_subsidy_log/indexof' + location.search,
                    // add_url: 'user/user_recruit_subsidy_log/add',
                    // edit_url: 'user/user_recruit_subsidy_log/edit',
                    // del_url: 'user/user_recruit_subsidy_log/del',
                    // multi_url: 'user/user_recruit_subsidy_log/multi',
                    // import_url: 'user/user_recruit_subsidy_log/import',
                    table: 'user_recruit_subsidy_log',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        // {field: 'user_id', title: __('User_id')},
                        {field: 'children.nickname', title: __('Children.nickname'), operate: 'LIKE'},
                        {field: 'children.avatar', title: __('Children.avatar'), operate: 'LIKE', events: Table.api.events.image, formatter: Table.api.formatter.image},
                        {field: 'recruit_subsidy', title: __('Recruit_subsidy'), operate:'BETWEEN'},
                        {field: 'children_id', title: __('Children_id'),visible:false},
                        // {field: 'work_date', title: __('Work_date')},
                        // {field: 'user_work_log_id', title: __('User_work_log_id')},
                        {field: 'leave', title: __('Leave'), searchList: {"0":__('Leave 0'),"1":__('Leave 1')}, formatter: Table.api.formatter.normal},
                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        // {field: 'leave', title: __('Leave')},
                        {field: 'operate', title: __('Operate'), table: table,
                            events: Table.api.events.operate,
                            buttons: [{
                                name: 'indexof',
                                text: __('查看收益'),
                                icon: 'fa fa-list',
                                classname: 'btn btn-info btn-xs btn-detail btn-dialog',
                                url: 'user/user_recruit_subsidy_log/indexof?xia_id={children_id}'
                            }],
                            formatter: Table.api.formatter.operate
                        }
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});