define(['jquery', 'bootstrap', 'backend', 'table', 'form'], function ($, undefined, Backend, Table, Form) {

    var Controller = {
        index: function () {
            // 初始化表格参数配置
            Table.api.init({
                extend: {
                    index_url: 'user/work_log/index' + location.search,
                    add_url: 'user/work_log/add',
                    edit_url: 'user/work_log/edit',
                    del_url: 'user/work_log/del',
                    multi_url: 'user/work_log/multi',
                    import_url: 'user/work_log/import',
                    table: 'user_work_log',
                }
            });

            var table = $("#table");

            // 初始化表格
            table.bootstrapTable({
                url: $.fn.bootstrapTable.defaults.extend.index_url,
                pk: 'id',
                sortName: 'id',
                columns: [
                    [
                        {checkbox: true},
                        {field: 'id', title: __('Id')},
                        {field: 'work_date', title: __('Work_date'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'work_hours', title: __('Work_hours'), operate:'BETWEEN'},
                        {field: 'work_price', title: __('Work_price'), operate:'BETWEEN'},
                        {field: 'work_salary', title: __('Work_salary'), operate:'BETWEEN'},
                        {field: 'work_type', title: __('Work_type'), searchList: {"1":__('Work_type 1'),"2":__('Work_type 2'),"3":__('Work_type 3')}, formatter: Table.api.formatter.normal},
                        {field: 'createtime', title: __('Createtime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        {field: 'updatetime', title: __('Updatetime'), operate:'RANGE', addclass:'datetimerange', autocomplete:false, formatter: Table.api.formatter.datetime},
                        // {field: 'operate', title: __('Operate'), table: table, events: Table.api.events.operate, formatter: Table.api.formatter.operate}
                    ]
                ]
            });

            // 为表格绑定事件
            Table.api.bindevent(table);
        },
        add: function () {
            Controller.api.bindevent();
        },
        edit: function () {
            Controller.api.bindevent();
        },
        api: {
            bindevent: function () {
                Form.api.bindevent($("form[role=form]"));
            }
        }
    };
    return Controller;
});